TesteTecnico/TesteTecnico/Models/ErrorViewModel.cs
namespace TesteTecnico.Models
{
    public class ErrorViewModel
    {
        public string? RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
    }
}

TesteTecnico/TesteTecnico/Controllers/HomeController.cs
using Application.Interfaces;
using Application.Model;
using Domain.Entity;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.IdentityModel.Tokens;
using System.Diagnostics;
using System.IdentityModel.Tokens.Jwt;
using System.Security.Claims;
using System.Text;
using TesteTecnico.Models;

namespace TesteTecnico.Controllers
{
    public class HomeController : Controller
    {
        private readonly ILogger<HomeController> _logger;
        private readonly IUserService _userService;

        public HomeController(ILogger<HomeController> logger, IUserService userService)
        {
            _logger = logger;
            _userService = userService;
        }

        public IActionResult Index()
        {
            HttpContext.Response.Cookies.Delete("UserId");
            HttpContext.Response.Cookies.Delete("UserName");

            return View("Login");
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }

        [HttpPost]
        public IActionResult Login(string email, string password)
        {
            var user = IsValidUser(email, password);

            if (user != null)
            {
                HttpContext.Response.Cookies.Append("UserId", user.Id.ToString());
                HttpContext.Response.Cookies.Append("UserName", user.Name);

                return RedirectToAction("Index", "Project");
            }
            else
            {
                return Unauthorized();
            }
        }

     
        [HttpGet]
        public IActionResult CreateUser()
        {
            return View();
        }

        [HttpPost]
        public IActionResult CreateUser(UserViewModel model)
        {
            _userService.CreateUser(model);
           
            ViewBag.Mensagem = "Registered successfully!";
            return View();
        }


        private UserViewModel IsValidUser(string email, string password)
        {
           return _userService.Authenticate(email, password);
        }

    }
}

TesteTecnico/TesteTecnico/Controllers/ProjectController.cs
using Application.Interfaces;
using Application.Model;
using Application.Services;
using Microsoft.AspNetCore.Mvc;

namespace TesteTecnico.Controllers
{
    public class ProjectController : Controller
    {
        private readonly IProjectService _projectService;

        public ProjectController(IProjectService projectService)
        {
            _projectService = projectService;
        }

        public IActionResult Index()
        {
            var list = _projectService.ListProjects().ToList();
            return View(list);
        }

        [HttpGet]
        public IActionResult Form()
        {
            var model = new ProjectViewModel();
            return View(model);
        }

        [HttpGet]
        public IActionResult Edit(long id)
        {
            var model = _projectService.GetById(id);
            return View("Form", model);
        }

        [HttpPost]
        public IActionResult InsertUpdate(ProjectViewModel model)
        {
            _projectService.InsertUpdate(model);

            ViewBag.Mensagem = "Registered successfully!";
            return View("Form", new ProjectViewModel());
        }

        [HttpGet]
        public IActionResult Delete(long id)
        {
            _projectService.Delete(id);

            return RedirectToAction("Index");
        }

    }
}

TesteTecnico/TesteTecnico/Controllers/TaskController.cs
using Application.Interfaces;
using Application.Model;
using Application.Enums;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;

namespace TesteTecnico.Controllers
{
    public class TaskController : Controller
    {
        private readonly ITaskService _taskService;
        private readonly IUserService _userService;
        private readonly IProjectService _projectService;

        public TaskController(ITaskService taskService, IUserService userService, IProjectService projectService)
        {
            _taskService = taskService;
            _userService = userService;
            _projectService = projectService;
        }

        public IActionResult Index()
        {
            var list = _taskService.ListTasks().ToList();
            return View(list);
        }

        [HttpGet]
        public IActionResult MyTask()
        {
            string userId = HttpContext.Request.Cookies["UserId"];
            var list = _taskService.ListMyTasks(Convert.ToInt64(userId)).ToList();
            return View("Index", list);
        }

        [HttpGet]
        public IActionResult Form()
        {
            LoadViewBags();
            var model = new TaskViewModel();
            return View(model);
        }


        [HttpGet]
        public IActionResult Edit(long id)
        {
            LoadViewBags();
            var model = _taskService.GetById(id);
            return View("Form", model);
        }


        private void LoadViewBags()
        {
            List<ProjectViewModel> listProjectViewModels = _projectService.ListProjects().ToList();
            ViewBag.ListProjects = new SelectList(listProjectViewModels, "Id", "Title");

            List<UserViewModel> listUserViewModels = _userService.ListUsers().ToList();
            ViewBag.ListUsers = new SelectList(listUserViewModels, "Id", "Name");


            var listTaskStatusEnum = Enum.GetValues(typeof(TaskStatusEnum))
               .Cast<TaskStatusEnum>()
               .Select(ec => new 
                   {
                       Id = (int)ec,
                       Name = ec.ToString()
                   })
                   .ToList();

            SelectList listStatus = new SelectList(listTaskStatusEnum, "Id", "Name");
            ViewBag.ListTaskStatus = listStatus;

        }


        [HttpPost]
        public IActionResult InsertUpdate(TaskViewModel model)
        {
            _taskService.InsertUpdate(model);

            ViewBag.Mensagem = "Registered successfully!";
            LoadViewBags();
            return View("Form", new TaskViewModel());
        }

        [HttpGet]
        public IActionResult Delete(long id)
        {
            _taskService.Delete(id);
           
            return RedirectToAction("Index");
        }

    }
}

TesteTecnico/TesteTecnico/Controllers/UserController.cs
using Application.Interfaces;
using Microsoft.AspNetCore.Mvc;

namespace TesteTecnico.Controllers
{
    public class UserController : Controller
    {

        private readonly IUserService _userService;

        public UserController(IUserService userService)
        {
            _userService = userService;
        }
        public IActionResult Index()
        {
            var list = _userService.ListUsers().ToList();
            return View(list);
        }


    }
}

TesteTecnico/TesteTecnico/Views/Home/CreateUser.cshtml
@{
    ViewData["Title"] = "Create User";
}

<div class="loginContainer">
    <div class="row justify-content-center">
        <div class="col-md-4">
            <h2 class="text-center">Create New User</h2>

            <form method="post" asp-controller="Home" asp-action="CreateUser">
                <div class="form-group">
                    <input type="text" id="name" name="name" class="form-control" placeholder="Full Name" required />
                </div>
                <div class="form-group">
                    <input type="text" id="email" name="email" class="form-control" placeholder="Email" required />
                </div>
                <div class="form-group">
                    <input type="password" id="password" name="password" class="form-control" placeholder="Password" required />
                </div>
                <div class="form-group text-center">
                    <button type="submit" class="btn action-btn mt-2">Save</button>
                    <button type="button" onclick="location.href='@Url.Action("Index", "Home")'" class="btn info-btn mt-2">Back</button>
                </div>
            </form>
            <div>
                @if (!string.IsNullOrEmpty(ViewBag.Mensagem))
                {
                    <p>@ViewBag.Mensagem</p>
                }
            </div>
        </div>
    </div>
</div>

TesteTecnico/TesteTecnico/Views/Home/Index.cshtml
@{
    ViewData["Title"] = "Home Page";
}

<div class="text-center">
    <h1 class="display-4">Welcome</h1>
    <p>Learn about <a href="https://docs.microsoft.com/aspnet/core">building Web apps with ASP.NET Core</a>.</p>
</div>

TesteTecnico/TesteTecnico/Views/Home/Login.cshtml
@{
    ViewData["Title"] = "Home Page";
}

<div class="loginContainer">
    <div class="row justify-content-center">
        <div class="col-md-4">
            <h2 class="text-center">Login</h2>

            <form method="post" asp-controller="Home" asp-action="Login">
                <div class="form-group">
                    <input type="text" id="email" name="email" class="form-control" placeholder="Email" required />
                </div>
                <div class="form-group">
                    <input type="password" id="password" name="password" class="form-control" placeholder="Password" required />
                </div>
                <div class="form-group text-center">
                    <button type="submit" class="btn btn-primary mt-2">Entrar</button>
                </div>
                <div class="form-group text-center">
                    @Html.ActionLink("Create New Account", "CreateUser", "Home")
                </div>
            </form>
        </div>
    </div>
    
</div>

TesteTecnico/TesteTecnico/Views/Project/Form.cshtml
@using Application.Model;
@model ProjectViewModel
@{
    ViewData["Title"] = "Create New Project";
}

<div class="loginContainer">
    <div class="row justify-content-center">
        <div class="col-md-4">
            <h2 class="text-center">Create New Project</h2>

            <form method="post" asp-controller="Project" asp-action="InsertUpdate">
                @Html.HiddenFor(x => x.Id)
                <div class="form-group">
                    <input type="text" id="title" name="title" value="@Model.Title" class="form-control" placeholder="Project Title" required />
                </div>
                <div class="form-group">
                    <textarea id="description" name="description" class="form-control" placeholder="Project Description" required>
                        @Model.Description
                    </textarea>
                </div>
                <div class="form-group">
                    <input type="date" id="createDate" name="createDate" value="@Model.CreateDate.ToString("yyyy-MM-dd")" class="form-control" placeholder="Project Create Date" required />
                </div>
                <div class="form-group text-center">
                    <button type="submit" class="btn action-btn mt-2">Save</button>
                    <button type="button" onclick="location.href='@Url.Action("Index", "Project")'" class="btn info-btn mt-2">Back</button>
                </div>
            </form>

            <div>
                @if (!string.IsNullOrEmpty(ViewBag.Mensagem))
                {
                    <p>@ViewBag.Mensagem</p>
                }
            </div>
        </div>
    </div>
</div>

TesteTecnico/TesteTecnico/Views/Project/Index.cshtml
@using Application.Model;
@model List<ProjectViewModel>
@{
    ViewData["Title"] = "Project List";
}

<div class="text-center">
    <h2 class="text-center">Project List</h2>
</div>

<table>
    <thead>
        <tr>
            <th>Title</th>
            <th>Description</th>
            <th>Create Date</th>
            <th>Actions</th>
        </tr>
    </thead>
    <tbody>
        @foreach(var item in Model)
        {
            <tr>
                <td>@item.Title</td>
                <td>@item.Description</td>
                <td>@item.CreateDate.ToString("dd/MM/yyyy")</td>
                <td>
                    <button type="button" onclick="location.href='@Url.Action("Edit", "Project", new { id = item.Id })'" class="btn action-btn">Edit</button>
                    <button type="button" onclick="location.href='@Url.Action("Delete", "Project", new { id = item.Id })'" class="btn delete-btn">Delete</button>
                </td>
            </tr>
        }

    </tbody>
</table>

<div class="form-group text-center">
    <button type="button" onclick="location.href='@Url.Action("Form", "Project")'" class="btn action-btn mt-2">Create New Project</button>
</div>

TesteTecnico/TesteTecnico/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - TesteTecnico</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" asp-append-version="true" />
    <link rel="stylesheet" href="~/TesteTecnico.styles.css" asp-append-version="true" />
   @* <style>
        body {
            display: flex;
            justify-content: center; /* Centraliza horizontalmente */
            align-items: center; /* Centraliza verticalmente */
            height: 100vh; 
            margin: 0; 
        }
        /*
        .loginContainer {
            width: 300px; 
            height: 200px; 
            background-color: lightgray;
            text-align: center; 
            padding: 20px; 
        }*/
    </style>*@
</head>
<body>
    <header>
        @{
            string userId = Context.Request.Cookies["UserId"];
        }

        @if (!string.IsNullOrEmpty(userId))
        {
            <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
                <div class="container-fluid">
                    <a href="#" class="navbar-brand">
                        Technical Test
                    </a>
                    <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                            aria-expanded="false" aria-label="Toggle navigation">
                        <span class="navbar-toggler-icon"></span>
                    </button>
                    <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                        <ul class="navbar-nav flex-grow-1">
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-area="" asp-controller="User" asp-action="Index">Users</a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-area="" asp-controller="Project" asp-action="Index">Projects</a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-area="" asp-controller="Task" asp-action="Index">Tasks</a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-area="" asp-controller="Task" asp-action="MyTask">My Tasks</a>
                            </li>
                        </ul>
                    </div>
                </div>
            </nav>
        }
        
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2023 - TesteTecnico - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>

TesteTecnico/TesteTecnico/Views/Task/Form.cshtml
@using Application.Model;
@model TaskViewModel
@{
    ViewData["Title"] = "Create New Task";
    var listProjects = ViewBag.ListProjects as SelectList;
    var listUsers = ViewBag.ListUsers as SelectList;
    var listTaskStatus = ViewBag.ListTaskStatus as SelectList;
}

<div class="loginContainer">
    <div class="row justify-content-center">
        <div class="col-md-4">
            <h2 class="text-center">Create New Task</h2>

            <form method="post" asp-controller="Task" asp-action="InsertUpdate">
                @Html.HiddenFor(x => x.Id)
                <div class="form-group">
                    <input type="text" id="title" name="title" value="@Model.Title" class="form-control" placeholder="Project Title" required />
                </div>
                <div class="form-group">
                    <textarea id="description" name="description" class="form-control" placeholder="Project Description" required>
                        @(!string.IsNullOrEmpty(Model.Description) ? Model.Description?.Trim() : "")
                    </textarea>
                </div>
                <div class="form-group">
                    @Html.DropDownList("ProjectId", listProjects, (Model.ProjectId > 0 ? Model.ProjectId.ToString() : "Select Project"), new { @class = "form-control" })
                </div>
                <div class="form-group">
                    <input type="date" id="createDate" name="createDate" value="@Model.CreateDate?.ToString("yyyy-MM-dd")" class="form-control" title="Task Create Date" required />
                </div>
                <div class="form-group">
                    <input type="date" id="completionDate" name="completionDate" value="@Model.CompletionDate?.ToString("yyyy-MM-dd")" class="form-control" title="Task Completion Date" required />
                </div>
                <div class="form-group">
                    @Html.DropDownList("UserId", listUsers, (Model.UserId > 0 ? Model.UserId.ToString() : "Select User"), new { @class = "form-control" })
                </div>
                <div class="form-group">
                    @Html.DropDownList("StatusId", listTaskStatus, (Model.StatusId > 0 ? Model.StatusId.ToString() : "Select Task Status"), new { @class = "form-control" })
                </div>
                <div class="form-group text-center">
                    <button type="submit" class="btn action-btn mt-2">Save</button>
                    <button type="button" onclick="location.href='@Url.Action("Index", "Task")'" class="btn info-btn mt-2">Back</button>
                </div>
                
            </form>

            <div>
                @if (!string.IsNullOrEmpty(ViewBag.Mensagem))
                {
                    <p>@ViewBag.Mensagem</p>
                }
            </div>
        </div>
    </div>
</div>

TesteTecnico/TesteTecnico/Views/Task/Index.cshtml
@using Application.Model;

@model List<TaskViewModel>
@{
    ViewData["Title"] = "Task List";
}

<div class="text-center">
    <h2 class="text-center">Task List</h2>
</div>
<div class="form-group text-center">
    <button type="button" onclick="location.href='@Url.Action("Form", "Task")'" class="btn action-btn mt-2">Create New Task</button>
</div>
<div class="conteiner">
    <div class="row">
        @foreach (var item in Model)
        {

            <div class="card" style="width: 18rem;">
                <div class="card-body">
                    <h4 class="card-title">@item.Project.Title</h4>
                    <h5 class="card-subtitle mb-2 text-muted">@item.Title</h5>
                    <p class="card-text">@item.Description</p>
                    <p class="card-text">@($"Developer: {item.User.Name}")</p>
                    <p class="card-text">@($"Create Date: {item.CreateDate?.ToString("dd/MM/yyyy")}")</p>
                    <p class="card-text">@($"Limit Date: {item.CompletionDate?.ToString("dd/MM/yyyy")}")</p>
                    <p class="card-text">@($"{Enum.GetName(typeof(Application.Enums.TaskStatusEnum), item.StatusId)}")</p>
                    <a href="@Url.Action("Edit", "Task", new { id = item.Id })" class="card-link">Edit Task</a>
                    <a href="@Url.Action("Delete", "Task", new { id = item.Id })" class="card-link">Delete Task</a>
                </div>
            </div>
        }
    </div>
</div>

TesteTecnico/TesteTecnico/Views/User/Index.cshtml
@using Application.Model;
@model List<UserViewModel>
@{
    ViewData["Title"] = "User List";
}

<div class="text-center">
    <h2 class="text-center">User List</h2>
</div>

<table>
    <thead>
        <tr>
            <th>Name</th>
            <th>Email</th>
            <th>Total Tasks</th>
        </tr>
    </thead>
    <tbody>
        @foreach(var item in Model)
        {
            <tr>
                <td>@item.Name</td>
                <td>@item.Email</td>
                <td>@item.TotalTask</td>
            </tr>
        }

    </tbody>
</table>